/* gen-index.c generated by valac 0.14.0, the Vala compiler
 * generated from gen-index.vala, do not modify */

/*
 * Copyright (C) 2011  Daiki Ueno
 * Copyright (C) 2011  Red Hat, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>
#include <gucharmap/gucharmap.h>
#include <stdio.h>
#include <gtk/gtk.h>


#define IBUS_GUCHARMAP_TYPE_INDEX_GENERATOR (ibus_gucharmap_index_generator_get_type ())
#define IBUS_GUCHARMAP_INDEX_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IBUS_GUCHARMAP_TYPE_INDEX_GENERATOR, IBusGucharmapIndexGenerator))
#define IBUS_GUCHARMAP_INDEX_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IBUS_GUCHARMAP_TYPE_INDEX_GENERATOR, IBusGucharmapIndexGeneratorClass))
#define IBUS_GUCHARMAP_IS_INDEX_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IBUS_GUCHARMAP_TYPE_INDEX_GENERATOR))
#define IBUS_GUCHARMAP_IS_INDEX_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IBUS_GUCHARMAP_TYPE_INDEX_GENERATOR))
#define IBUS_GUCHARMAP_INDEX_GENERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IBUS_GUCHARMAP_TYPE_INDEX_GENERATOR, IBusGucharmapIndexGeneratorClass))

typedef struct _IBusGucharmapIndexGenerator IBusGucharmapIndexGenerator;
typedef struct _IBusGucharmapIndexGeneratorClass IBusGucharmapIndexGeneratorClass;
typedef struct _IBusGucharmapIndexGeneratorPrivate IBusGucharmapIndexGeneratorPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))

struct _IBusGucharmapIndexGenerator {
	GObject parent_instance;
	IBusGucharmapIndexGeneratorPrivate * priv;
};

struct _IBusGucharmapIndexGeneratorClass {
	GObjectClass parent_class;
};

struct _IBusGucharmapIndexGeneratorPrivate {
	gchar* filename;
};


static gpointer ibus_gucharmap_index_generator_parent_class = NULL;

GType ibus_gucharmap_index_generator_get_type (void) G_GNUC_CONST;
#define IBUS_GUCHARMAP_INDEX_GENERATOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), IBUS_GUCHARMAP_TYPE_INDEX_GENERATOR, IBusGucharmapIndexGeneratorPrivate))
enum  {
	IBUS_GUCHARMAP_INDEX_GENERATOR_DUMMY_PROPERTY
};
#define IBUS_GUCHARMAP_INDEX_GENERATOR_create_schema "\n" \
"DROP TABLE IF EXISTS unicode_blocks;\n" \
"CREATE TABLE unicode_blocks (\n" \
"    id INTEGER PRIMARY KEY ASC,\n" \
"    name TEXT,\n" \
"    first_codepoint INTEGER,\n" \
"    last_codepoint INTEGER\n" \
");\n" \
"\n" \
"DROP INDEX IF EXISTS unicode_blocks_by_name;\n" \
"CREATE INDEX unicode_blocks_by_name ON unicode_blocks (name);\n" \
"\n" \
"DROP TABLE IF EXISTS unicode_names;\n" \
"CREATE TABLE unicode_names (\n" \
"    codepoint INTEGER PRIMARY KEY,\n" \
"    name TEXT,\n" \
"    block_id INTEGER\n" \
");\n" \
"\n" \
"DROP INDEX IF EXISTS unicode_names_by_name;\n" \
"CREATE INDEX unicode_names_by_name ON unicode_names (name);\n"
IBusGucharmapIndexGenerator* ibus_gucharmap_index_generator_new (const gchar* filename);
IBusGucharmapIndexGenerator* ibus_gucharmap_index_generator_construct (GType object_type, const gchar* filename);
static gboolean ibus_gucharmap_index_generator_insert_block (IBusGucharmapIndexGenerator* self, sqlite3* database, GucharmapBlockChaptersModel* model, gint block_id, guint first_codepoint, guint last_codepoint);
static gboolean ibus_gucharmap_index_generator_insert_blocks (IBusGucharmapIndexGenerator* self, sqlite3* database);
gboolean ibus_gucharmap_index_generator_generate (IBusGucharmapIndexGenerator* self);
static void ibus_gucharmap_index_generator_finalize (GObject* obj);
gint ibus_gucharmap_main (gchar** args, int args_length1);


IBusGucharmapIndexGenerator* ibus_gucharmap_index_generator_construct (GType object_type, const gchar* filename) {
	IBusGucharmapIndexGenerator * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (filename != NULL, NULL);
	self = (IBusGucharmapIndexGenerator*) g_object_new (object_type, NULL);
	_tmp0_ = filename;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->filename);
	self->priv->filename = _tmp1_;
	return self;
}


IBusGucharmapIndexGenerator* ibus_gucharmap_index_generator_new (const gchar* filename) {
	return ibus_gucharmap_index_generator_construct (IBUS_GUCHARMAP_TYPE_INDEX_GENERATOR, filename);
}


static gboolean ibus_gucharmap_index_generator_insert_block (IBusGucharmapIndexGenerator* self, sqlite3* database, GucharmapBlockChaptersModel* model, gint block_id, guint first_codepoint, guint last_codepoint) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (database != NULL, FALSE);
	g_return_val_if_fail (model != NULL, FALSE);
	{
		guint _tmp0_;
		guint uc;
		_tmp0_ = first_codepoint;
		uc = _tmp0_;
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
			while (TRUE) {
				gboolean _tmp2_;
				guint _tmp4_;
				guint _tmp5_;
				guint _tmp6_;
				gboolean _tmp7_ = FALSE;
				gchar* _tmp8_;
				gchar* sql;
				gint rc = 0;
				sqlite3_stmt* stmt = NULL;
				sqlite3* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				sqlite3_stmt* _tmp14_ = NULL;
				gint _tmp15_ = 0;
				gint _tmp16_;
				sqlite3_stmt* _tmp20_;
				guint _tmp21_;
				gint _tmp22_ = 0;
				gint _tmp23_;
				guint _tmp27_;
				const gchar* _tmp28_ = NULL;
				gchar* _tmp29_;
				gchar* name;
				sqlite3_stmt* _tmp30_;
				const gchar* _tmp31_;
				gchar* _tmp32_ = NULL;
				GDestroyNotify _tmp33_;
				gint _tmp34_ = 0;
				gint _tmp35_;
				sqlite3_stmt* _tmp39_;
				gint _tmp40_;
				gint _tmp41_ = 0;
				gint _tmp42_;
				sqlite3_stmt* _tmp46_;
				gint _tmp47_ = 0;
				gint _tmp48_;
				_tmp2_ = _tmp1_;
				if (!_tmp2_) {
					guint _tmp3_;
					_tmp3_ = uc;
					uc = _tmp3_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp4_ = uc;
				_tmp5_ = last_codepoint;
				if (!(_tmp4_ < _tmp5_)) {
					break;
				}
				_tmp6_ = uc;
				_tmp7_ = gucharmap_unichar_isdefined ((gunichar) _tmp6_);
				if (!_tmp7_) {
					continue;
				}
				_tmp8_ = g_strdup ("INSERT INTO unicode_names VALUES (?, ?, ?);");
				sql = _tmp8_;
				_tmp9_ = database;
				_tmp10_ = sql;
				_tmp11_ = sql;
				_tmp12_ = strlen (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp15_ = sqlite3_prepare (_tmp9_, _tmp10_, _tmp13_, &_tmp14_, NULL);
				_sqlite3_finalize0 (stmt);
				stmt = _tmp14_;
				rc = _tmp15_;
				_tmp16_ = rc;
				if (_tmp16_ != SQLITE_OK) {
					FILE* _tmp17_;
					sqlite3* _tmp18_;
					const gchar* _tmp19_ = NULL;
					_tmp17_ = stderr;
					_tmp18_ = database;
					_tmp19_ = sqlite3_errmsg (_tmp18_);
					fprintf (_tmp17_, "can't prepare statement: %s\n", _tmp19_);
					result = FALSE;
					_sqlite3_finalize0 (stmt);
					_g_free0 (sql);
					return result;
				}
				_tmp20_ = stmt;
				_tmp21_ = uc;
				_tmp22_ = sqlite3_bind_int64 (_tmp20_, 1, (gint64) _tmp21_);
				rc = _tmp22_;
				_tmp23_ = rc;
				if (_tmp23_ != SQLITE_OK) {
					FILE* _tmp24_;
					sqlite3* _tmp25_;
					const gchar* _tmp26_ = NULL;
					_tmp24_ = stderr;
					_tmp25_ = database;
					_tmp26_ = sqlite3_errmsg (_tmp25_);
					fprintf (_tmp24_, "can't bind values: %s\n", _tmp26_);
					result = FALSE;
					_sqlite3_finalize0 (stmt);
					_g_free0 (sql);
					return result;
				}
				_tmp27_ = uc;
				_tmp28_ = gucharmap_get_unicode_name ((gunichar) _tmp27_);
				_tmp29_ = g_strdup (_tmp28_);
				name = _tmp29_;
				_tmp30_ = stmt;
				_tmp31_ = name;
				_tmp32_ = g_strdup (_tmp31_);
				_tmp33_ = g_free;
				_tmp34_ = sqlite3_bind_text (_tmp30_, 2, _tmp32_, -1, _tmp33_);
				rc = _tmp34_;
				_tmp35_ = rc;
				if (_tmp35_ != SQLITE_OK) {
					FILE* _tmp36_;
					sqlite3* _tmp37_;
					const gchar* _tmp38_ = NULL;
					_tmp36_ = stderr;
					_tmp37_ = database;
					_tmp38_ = sqlite3_errmsg (_tmp37_);
					fprintf (_tmp36_, "can't bind values: %s\n", _tmp38_);
					result = FALSE;
					_g_free0 (name);
					_sqlite3_finalize0 (stmt);
					_g_free0 (sql);
					return result;
				}
				_tmp39_ = stmt;
				_tmp40_ = block_id;
				_tmp41_ = sqlite3_bind_int64 (_tmp39_, 3, (gint64) _tmp40_);
				rc = _tmp41_;
				_tmp42_ = rc;
				if (_tmp42_ != SQLITE_OK) {
					FILE* _tmp43_;
					sqlite3* _tmp44_;
					const gchar* _tmp45_ = NULL;
					_tmp43_ = stderr;
					_tmp44_ = database;
					_tmp45_ = sqlite3_errmsg (_tmp44_);
					fprintf (_tmp43_, "can't bind values: %s\n", _tmp45_);
					result = FALSE;
					_g_free0 (name);
					_sqlite3_finalize0 (stmt);
					_g_free0 (sql);
					return result;
				}
				_tmp46_ = stmt;
				_tmp47_ = sqlite3_step (_tmp46_);
				rc = _tmp47_;
				_tmp48_ = rc;
				if (_tmp48_ != SQLITE_DONE) {
					FILE* _tmp49_;
					sqlite3* _tmp50_;
					const gchar* _tmp51_ = NULL;
					_tmp49_ = stderr;
					_tmp50_ = database;
					_tmp51_ = sqlite3_errmsg (_tmp50_);
					fprintf (_tmp49_, "can't commit the change: %s\n", _tmp51_);
					result = FALSE;
					_g_free0 (name);
					_sqlite3_finalize0 (stmt);
					_g_free0 (sql);
					return result;
				}
				_g_free0 (name);
				_sqlite3_finalize0 (stmt);
				_g_free0 (sql);
			}
		}
	}
	result = TRUE;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean ibus_gucharmap_index_generator_insert_blocks (IBusGucharmapIndexGenerator* self, sqlite3* database) {
	gboolean result = FALSE;
	GucharmapBlockChaptersModel* _tmp0_;
	GucharmapBlockChaptersModel* model;
	GtkTreeIter iter = {0};
	gint block_id = 0;
	GucharmapBlockChaptersModel* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	gboolean _tmp3_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (database != NULL, FALSE);
	_tmp0_ = (GucharmapBlockChaptersModel*) gucharmap_block_chapters_model_new ();
	model = _tmp0_;
	_tmp1_ = model;
	_tmp3_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp1_, &_tmp2_);
	iter = _tmp2_;
	if (!_tmp3_) {
		result = FALSE;
		_g_object_unref0 (model);
		return result;
	}
	block_id = 1;
	{
		gboolean _tmp4_;
		_tmp4_ = TRUE;
		while (TRUE) {
			gboolean _tmp5_;
			gchar* name = NULL;
			GucharmapBlockChaptersModel* _tmp8_;
			GtkTreeIter _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp12_;
			gchar* sql;
			gint rc = 0;
			sqlite3_stmt* stmt = NULL;
			sqlite3* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			sqlite3_stmt* _tmp18_ = NULL;
			gint _tmp19_ = 0;
			gint _tmp20_;
			sqlite3_stmt* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_ = NULL;
			GDestroyNotify _tmp27_;
			gint _tmp28_ = 0;
			gint _tmp29_;
			GucharmapBlockChaptersModel* _tmp33_;
			GtkTreeIter _tmp34_;
			GucharmapCodepointList* _tmp35_ = NULL;
			GucharmapBlockCodepointList* _tmp36_;
			GucharmapBlockCodepointList* codepoint_list;
			sqlite3_stmt* _tmp37_;
			GucharmapBlockCodepointList* _tmp38_;
			guint _tmp39_ = 0U;
			guint _tmp40_;
			gint _tmp41_ = 0;
			gint _tmp42_;
			sqlite3_stmt* _tmp46_;
			GucharmapBlockCodepointList* _tmp47_;
			guint _tmp48_ = 0U;
			guint _tmp49_;
			gint _tmp50_ = 0;
			gint _tmp51_;
			sqlite3_stmt* _tmp55_;
			gint _tmp56_ = 0;
			gint _tmp57_;
			sqlite3* _tmp61_;
			GucharmapBlockChaptersModel* _tmp62_;
			gint _tmp63_;
			GucharmapBlockCodepointList* _tmp64_;
			guint _tmp65_ = 0U;
			guint _tmp66_;
			GucharmapBlockCodepointList* _tmp67_;
			guint _tmp68_ = 0U;
			guint _tmp69_;
			_tmp5_ = _tmp4_;
			if (!_tmp5_) {
				GucharmapBlockChaptersModel* _tmp6_;
				gboolean _tmp7_ = FALSE;
				_tmp6_ = model;
				_tmp7_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp6_, &iter);
				if (!_tmp7_) {
					break;
				}
			}
			_tmp4_ = FALSE;
			_tmp8_ = model;
			_tmp9_ = iter;
			gtk_tree_model_get ((GtkTreeModel*) _tmp8_, &_tmp9_, 0, &name, -1);
			_tmp10_ = name;
			if (g_strcmp0 (_tmp10_, "All") == 0) {
				gint _tmp11_;
				_tmp11_ = block_id;
				block_id = _tmp11_ + 1;
				_g_free0 (name);
				continue;
			}
			_tmp12_ = g_strdup ("INSERT INTO unicode_blocks VALUES (?, ?, ?, ?);");
			sql = _tmp12_;
			_tmp13_ = database;
			_tmp14_ = sql;
			_tmp15_ = sql;
			_tmp16_ = strlen (_tmp15_);
			_tmp17_ = _tmp16_;
			_tmp19_ = sqlite3_prepare (_tmp13_, _tmp14_, _tmp17_, &_tmp18_, NULL);
			_sqlite3_finalize0 (stmt);
			stmt = _tmp18_;
			rc = _tmp19_;
			_tmp20_ = rc;
			if (_tmp20_ != SQLITE_OK) {
				FILE* _tmp21_;
				sqlite3* _tmp22_;
				const gchar* _tmp23_ = NULL;
				_tmp21_ = stderr;
				_tmp22_ = database;
				_tmp23_ = sqlite3_errmsg (_tmp22_);
				fprintf (_tmp21_, "can't prepare statement: %s\n", _tmp23_);
				result = FALSE;
				_sqlite3_finalize0 (stmt);
				_g_free0 (sql);
				_g_free0 (name);
				_g_object_unref0 (model);
				return result;
			}
			_tmp24_ = stmt;
			_tmp25_ = name;
			_tmp26_ = g_strdup (_tmp25_);
			_tmp27_ = g_free;
			_tmp28_ = sqlite3_bind_text (_tmp24_, 2, _tmp26_, -1, _tmp27_);
			rc = _tmp28_;
			_tmp29_ = rc;
			if (_tmp29_ != SQLITE_OK) {
				FILE* _tmp30_;
				sqlite3* _tmp31_;
				const gchar* _tmp32_ = NULL;
				_tmp30_ = stderr;
				_tmp31_ = database;
				_tmp32_ = sqlite3_errmsg (_tmp31_);
				fprintf (_tmp30_, "can't bind values: %s\n", _tmp32_);
				result = FALSE;
				_sqlite3_finalize0 (stmt);
				_g_free0 (sql);
				_g_free0 (name);
				_g_object_unref0 (model);
				return result;
			}
			_tmp33_ = model;
			_tmp34_ = iter;
			_tmp35_ = gucharmap_chapters_model_get_codepoint_list ((GucharmapChaptersModel*) _tmp33_, &_tmp34_);
			_tmp36_ = _g_object_ref0 (GUCHARMAP_BLOCK_CODEPOINT_LIST (_tmp35_));
			codepoint_list = _tmp36_;
			_tmp37_ = stmt;
			_tmp38_ = codepoint_list;
			g_object_get (_tmp38_, "first-codepoint", &_tmp39_, NULL);
			_tmp40_ = _tmp39_;
			_tmp41_ = sqlite3_bind_int64 (_tmp37_, 3, (gint64) _tmp40_);
			rc = _tmp41_;
			_tmp42_ = rc;
			if (_tmp42_ != SQLITE_OK) {
				FILE* _tmp43_;
				sqlite3* _tmp44_;
				const gchar* _tmp45_ = NULL;
				_tmp43_ = stderr;
				_tmp44_ = database;
				_tmp45_ = sqlite3_errmsg (_tmp44_);
				fprintf (_tmp43_, "can't bind values: %s\n", _tmp45_);
				result = FALSE;
				_g_object_unref0 (codepoint_list);
				_sqlite3_finalize0 (stmt);
				_g_free0 (sql);
				_g_free0 (name);
				_g_object_unref0 (model);
				return result;
			}
			_tmp46_ = stmt;
			_tmp47_ = codepoint_list;
			g_object_get (_tmp47_, "last-codepoint", &_tmp48_, NULL);
			_tmp49_ = _tmp48_;
			_tmp50_ = sqlite3_bind_int64 (_tmp46_, 4, (gint64) _tmp49_);
			rc = _tmp50_;
			_tmp51_ = rc;
			if (_tmp51_ != SQLITE_OK) {
				FILE* _tmp52_;
				sqlite3* _tmp53_;
				const gchar* _tmp54_ = NULL;
				_tmp52_ = stderr;
				_tmp53_ = database;
				_tmp54_ = sqlite3_errmsg (_tmp53_);
				fprintf (_tmp52_, "can't bind values: %s\n", _tmp54_);
				result = FALSE;
				_g_object_unref0 (codepoint_list);
				_sqlite3_finalize0 (stmt);
				_g_free0 (sql);
				_g_free0 (name);
				_g_object_unref0 (model);
				return result;
			}
			_tmp55_ = stmt;
			_tmp56_ = sqlite3_step (_tmp55_);
			rc = _tmp56_;
			_tmp57_ = rc;
			if (_tmp57_ != SQLITE_DONE) {
				FILE* _tmp58_;
				sqlite3* _tmp59_;
				const gchar* _tmp60_ = NULL;
				_tmp58_ = stderr;
				_tmp59_ = database;
				_tmp60_ = sqlite3_errmsg (_tmp59_);
				fprintf (_tmp58_, "can't commit the change: %s\n", _tmp60_);
				result = FALSE;
				_g_object_unref0 (codepoint_list);
				_sqlite3_finalize0 (stmt);
				_g_free0 (sql);
				_g_free0 (name);
				_g_object_unref0 (model);
				return result;
			}
			_tmp61_ = database;
			_tmp62_ = model;
			_tmp63_ = block_id;
			block_id = _tmp63_ + 1;
			_tmp64_ = codepoint_list;
			g_object_get (_tmp64_, "first-codepoint", &_tmp65_, NULL);
			_tmp66_ = _tmp65_;
			_tmp67_ = codepoint_list;
			g_object_get (_tmp67_, "last-codepoint", &_tmp68_, NULL);
			_tmp69_ = _tmp68_;
			ibus_gucharmap_index_generator_insert_block (self, _tmp61_, _tmp62_, _tmp63_, _tmp66_, _tmp69_);
			_g_object_unref0 (codepoint_list);
			_sqlite3_finalize0 (stmt);
			_g_free0 (sql);
			_g_free0 (name);
		}
	}
	result = TRUE;
	_g_object_unref0 (model);
	return result;
}


static gint _sqlite3_exec (sqlite3* self, const gchar* sql, sqlite3_callback callback, void* callback_target, gchar** errmsg) {
	gchar* _vala_errmsg = NULL;
	gint result = 0;
	const gchar* sqlite_errmsg = NULL;
	const gchar* _tmp0_;
	sqlite3_callback _tmp1_;
	void* _tmp1__target;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint ec;
	const gchar* _tmp6_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (sql != NULL, 0);
	_tmp0_ = sql;
	_tmp1_ = callback;
	_tmp1__target = callback_target;
	_tmp3_ = sqlite3_exec (self, _tmp0_, _tmp1_, _tmp1__target, (char**) (&_tmp2_));
	sqlite_errmsg = _tmp2_;
	ec = _tmp3_;
	if ((&_vala_errmsg) != NULL) {
		const gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp4_ = sqlite_errmsg;
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (_vala_errmsg);
		_vala_errmsg = _tmp5_;
	}
	_tmp6_ = sqlite_errmsg;
	sqlite3_free ((void*) _tmp6_);
	result = ec;
	if (errmsg) {
		*errmsg = _vala_errmsg;
	} else {
		_g_free0 (_vala_errmsg);
	}
	return result;
}


gboolean ibus_gucharmap_index_generator_generate (IBusGucharmapIndexGenerator* self) {
	gboolean result = FALSE;
	sqlite3* database = NULL;
	gint rc = 0;
	const gchar* _tmp0_;
	sqlite3* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_;
	sqlite3* _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_;
	sqlite3* _tmp11_;
	gint _tmp12_ = 0;
	gint _tmp13_;
	sqlite3* _tmp17_;
	gboolean _tmp18_ = FALSE;
	sqlite3* _tmp19_;
	gint _tmp20_ = 0;
	gint _tmp21_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->filename;
	_tmp2_ = sqlite3_open (_tmp0_, &_tmp1_);
	_sqlite3_close0 (database);
	database = _tmp1_;
	rc = _tmp2_;
	_tmp3_ = rc;
	if (_tmp3_ != SQLITE_OK) {
		FILE* _tmp4_;
		_tmp4_ = stderr;
		fprintf (_tmp4_, "can't open database\n");
		result = FALSE;
		_sqlite3_close0 (database);
		return result;
	}
	_tmp5_ = database;
	_tmp6_ = _sqlite3_exec (_tmp5_, IBUS_GUCHARMAP_INDEX_GENERATOR_create_schema, NULL, NULL, NULL);
	rc = _tmp6_;
	_tmp7_ = rc;
	if (_tmp7_ != SQLITE_OK) {
		FILE* _tmp8_;
		sqlite3* _tmp9_;
		const gchar* _tmp10_ = NULL;
		_tmp8_ = stderr;
		_tmp9_ = database;
		_tmp10_ = sqlite3_errmsg (_tmp9_);
		fprintf (_tmp8_, "can't create tables: %s\n", _tmp10_);
		result = FALSE;
		_sqlite3_close0 (database);
		return result;
	}
	_tmp11_ = database;
	_tmp12_ = _sqlite3_exec (_tmp11_, "BEGIN;", NULL, NULL, NULL);
	rc = _tmp12_;
	_tmp13_ = rc;
	if (_tmp13_ != SQLITE_OK) {
		FILE* _tmp14_;
		sqlite3* _tmp15_;
		const gchar* _tmp16_ = NULL;
		_tmp14_ = stderr;
		_tmp15_ = database;
		_tmp16_ = sqlite3_errmsg (_tmp15_);
		fprintf (_tmp14_, "can't start transaction: %s\n", _tmp16_);
		result = FALSE;
		_sqlite3_close0 (database);
		return result;
	}
	_tmp17_ = database;
	_tmp18_ = ibus_gucharmap_index_generator_insert_blocks (self, _tmp17_);
	if (!_tmp18_) {
		result = FALSE;
		_sqlite3_close0 (database);
		return result;
	}
	_tmp19_ = database;
	_tmp20_ = _sqlite3_exec (_tmp19_, "COMMIT;", NULL, NULL, NULL);
	rc = _tmp20_;
	_tmp21_ = rc;
	if (_tmp21_ != SQLITE_OK) {
		FILE* _tmp22_;
		sqlite3* _tmp23_;
		const gchar* _tmp24_ = NULL;
		_tmp22_ = stderr;
		_tmp23_ = database;
		_tmp24_ = sqlite3_errmsg (_tmp23_);
		fprintf (_tmp22_, "can't complete transaction: %s\n", _tmp24_);
		result = FALSE;
		_sqlite3_close0 (database);
		return result;
	}
	result = TRUE;
	_sqlite3_close0 (database);
	return result;
}


static void ibus_gucharmap_index_generator_class_init (IBusGucharmapIndexGeneratorClass * klass) {
	ibus_gucharmap_index_generator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (IBusGucharmapIndexGeneratorPrivate));
	G_OBJECT_CLASS (klass)->finalize = ibus_gucharmap_index_generator_finalize;
}


static void ibus_gucharmap_index_generator_instance_init (IBusGucharmapIndexGenerator * self) {
	self->priv = IBUS_GUCHARMAP_INDEX_GENERATOR_GET_PRIVATE (self);
}


static void ibus_gucharmap_index_generator_finalize (GObject* obj) {
	IBusGucharmapIndexGenerator * self;
	self = IBUS_GUCHARMAP_INDEX_GENERATOR (obj);
	_g_free0 (self->priv->filename);
	G_OBJECT_CLASS (ibus_gucharmap_index_generator_parent_class)->finalize (obj);
}


GType ibus_gucharmap_index_generator_get_type (void) {
	static volatile gsize ibus_gucharmap_index_generator_type_id__volatile = 0;
	if (g_once_init_enter (&ibus_gucharmap_index_generator_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IBusGucharmapIndexGeneratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ibus_gucharmap_index_generator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IBusGucharmapIndexGenerator), 0, (GInstanceInitFunc) ibus_gucharmap_index_generator_instance_init, NULL };
		GType ibus_gucharmap_index_generator_type_id;
		ibus_gucharmap_index_generator_type_id = g_type_register_static (G_TYPE_OBJECT, "IBusGucharmapIndexGenerator", &g_define_type_info, 0);
		g_once_init_leave (&ibus_gucharmap_index_generator_type_id__volatile, ibus_gucharmap_index_generator_type_id);
	}
	return ibus_gucharmap_index_generator_type_id__volatile;
}


gint ibus_gucharmap_main (gchar** args, int args_length1) {
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** _tmp3_;
	gint _tmp3__length1;
	const gchar* _tmp4_;
	IBusGucharmapIndexGenerator* _tmp5_;
	IBusGucharmapIndexGenerator* generator;
	IBusGucharmapIndexGenerator* _tmp6_;
	_tmp0_ = gtk_init_check (&args_length1, &args);
	if (!_tmp0_) {
		g_warning ("gen-index.vala:215: Can't init GTK, but ignoring the error");
	}
	_tmp1_ = args;
	_tmp1__length1 = args_length1;
	if (_tmp1__length1 < 2) {
		FILE* _tmp2_;
		_tmp2_ = stderr;
		fprintf (_tmp2_, "Usage: gen-index FILENAME\n");
		result = 1;
		return result;
	}
	_tmp3_ = args;
	_tmp3__length1 = args_length1;
	_tmp4_ = _tmp3_[1];
	_tmp5_ = ibus_gucharmap_index_generator_new (_tmp4_);
	generator = _tmp5_;
	_tmp6_ = generator;
	ibus_gucharmap_index_generator_generate (_tmp6_);
	result = 0;
	_g_object_unref0 (generator);
	return result;
}


int main (int argc, char ** argv) {
	g_type_init ();
	return ibus_gucharmap_main (argv, argc);
}



